B. More Cowbell
Time Limit: 20 Sec
Memory Limit: 256 MB
题目连接
http://codeforces.com/contest/604/problem/B
Description
Kevin Sun wants to move his precious collection of n cowbells from Naperthrill to Exeter, where there is actually grass instead of corn. Before moving, he must pack his cowbells into k boxes of a fixed size. In order to keep his collection safe during transportation, he won't place more than two cowbells into a single box. Since Kevin wishes to minimize expenses, he is curious about the smallest size box he can use to pack his entire collection.
Kevin is a meticulous cowbell collector and knows that the size of his i-th (1 ≤ i ≤ n) cowbell is an integer si. In fact, he keeps his cowbells sorted by size, so si - 1 ≤ si for any i > 1. Also an expert packer, Kevin can fit one or two cowbells into a box of size s if and only if the sum of their sizes does not exceed s. Given this information, help Kevin determine the smallest s for which it is possible to put all of his cowbells into k boxes of size s.
Input
The first line of the input contains two space-separated integers n and k (1 ≤ n ≤ 2·k ≤ 100 000), denoting the number of cowbells and the number of boxes, respectively.
The next line contains n space-separated integers s1, s2, ..., sn (1 ≤ s1 ≤ s2 ≤ ... ≤ sn ≤ 1 000 000), the sizes of Kevin's cowbells. It is guaranteed that the sizes si are given in non-decreasing order.
Output
Print a single integer, the smallest s for which it is possible for Kevin to put all of his cowbells into k boxes of size s.
Sample Input
2 1
2 5
Sample Output
7
HINT
题意
给你n个物品,k个盒子,每个盒子最多可以塞进去2个物品,但是塞进去的物品的权值和必须小于盒子的权值
问你盒子的权值最小可以为多少
保证n<=2*k
题解:
二分答案,check的时候,有一个贪心
最小的+最大的这样扔进去,比两个最小的这样扔进去更加优越
代码:
#include<iostream>
#include<math.h>
#include<stdio.h>
#include<algorithm>
using namespace std; int n,k;
int a[];
int check(int x)
{
for(int i=;i<=n;i++)
if(a[i]>x)return ;
int ans = ;
int st = ,ed = n;
while()
{
if(st>ed)break;
if(a[st]+a[ed]<=x)
{
st++,ed--;
ans++;
}
else
{
ed--;
ans++;
}
}
if(ans<=k)return ;
return ;
}
int main()
{
scanf("%d%d",&n,&k);
for(int i=;i<=n;i++)
scanf("%d",&a[i]);
int l = ,r = * ;
while(l<=r)
{
int mid = (l+r)/;
if(check(mid))r = mid-;
else l = mid+;
}
printf("%d\n",l);
}